        TITLE   'T8253'
CODE    SEGMENT BYTE    PUBLIC  'TEXT'
        ASSUME  CS:CODE, DS:CODE
        ORG     100H
LOCALS  @@

Begin:          JMP     Install

SPEED           EQU     1111H
MAGIC           EQU     8888H
MAIN_ID         DB      0FFH
BUSY            DB      0
DIVIDER         DW      1
COUNTER         DW      1

Int_2F  PROC    FAR
                CMP     AH, CS:[MAIN_ID]
                JE      @@1
                DB      0EAH
OFS_KEEP2F      DW      ?
SEG_KEEP2F      DW      ?
@@1:            MOV     AL, 0FFH
                MOV     BX, MAGIC
                MOV     DX, BX
                IRET
Int_2F  ENDP

Int_08  PROC    FAR
                CLI
                PUSH    AX
                DEC     CS:[COUNTER]
                JNZ     @@1
                MOV     AX, CS:[DIVIDER]
                MOV     CS:[COUNTER], AX
                PUSHF
                DB      09AH
OFS_KEEP08      DW      ?
SEG_KEEP08      DW      ?
                JMP     @@2
@@1:            MOV     AL, 20H
                OUT     20H, AL
@@2:            TEST    CS:[BUSY], 255
                JNZ     @@Q
                INC     CS:[BUSY]
                STI
                PUSH    ES
                XOR     AX, AX
                MOV     ES, AX
                PUSHF
                CALL    DWORD PTR ES:[08CH*4]
                POP     ES
                DEC     CS:[BUSY]
@@Q:            POP     AX
                IRET
Int_08  ENDP

Int_8C  PROC    FAR
                IRET
Int_8C  ENDP

Int_21  PROC    FAR
                CMP     AX, 3508
                JE      @@GET
                CMP     AX, 2508
                JE      @@SET
                DB      0EAH
OFS_KEEP21      DW      ?
SEG_KEEP21      DW      ?
@@GET:          MOV     BX, CS:[OFS_KEEP08]
                MOV     ES, CS:[SEG_KEEP08]
                JMP     @@Q
@@SET:          CLI
                MOV     CS:[OFS_KEEP08], DX
                MOV     CS:[SEG_KEEP08], DS
@@Q:            IRET
Int_21  ENDP

;
; ******** ⠫ *******
;
Install:
                PUSH    DS
                POP     ES
                PUSH    CS
                POP     DS
                LEA     DX, [Message]
                MOV     AH, 9
                INT     21H
                MOV     CL, 080H
        @@1:    MOV     AH, CL
                MOV     AL, 1
                PUSH    CX
                INT     02FH
                POP     CX
                CMP     AL, 0FFH
                JNE     @@2
                OR      AL, AL
                JNZ     @@3
                MOV     [MAIN_ID], CL
        @@3:    MOV     AL, 1
                CMP     BX, MAGIC
                JNE     @@2
                XOR     BX, DX
                JNZ     @@2
                JMP     UnInstall
        @@2:    ADD     CL, 1
                JNC     @@1
                PUSH    ES
                MOV     AX, 352FH
                INT     21H
                MOV     [OFS_KEEP2F], BX
                MOV     [SEG_KEEP2F], ES
                LEA     DX, [Int_2F]
                MOV     AX, 252FH
                INT     21H
                LEA     DX, [Int_8C]
                MOV     AX, 258CH
                INT     21H
                MOV     AX, 3508H
                INT     21H
                MOV     [OFS_KEEP08], BX
                MOV     [SEG_KEEP08], ES
                LEA     DX, [Int_08]
                MOV     AX, 2508H
                INT     21H
                CLI
                MOV     AL, 00110110B
                OUT     43H, AL
                MOV     AX, SPEED
                OUT     40H, AL
                MOV     AL, AH
                OUT     40H, AL
                MOV     [DIVIDER], 15
                STI
                MOV     AX, 3521H
                INT     21H
                MOV     [OFS_KEEP21], BX
                MOV     [SEG_KEEP21], ES
                LEA     DX, [Int_21]
                MOV     AX, 2521H
                INT     21H
                LEA     DX, [Msg_Load]
                MOV     AH, 9
                INT     21H
                POP     ES
                MOV     ES, ES:[2CH]
                MOV     AH, 49H
                INT     21H
                LEA     DX, [Install]
                INT     27H
UnInstall:      MOV     AX, 352FH
                INT     21H
                CLI
                MOV     AL, 00110110B
                OUT     43H, AL
                MOV     AX, 0FFFFH
                OUT     40H, AL
                MOV     AL, AH
                OUT     40H, AL
                MOV     ES:[DIVIDER], 1
                MOV     ES:[COUNTER], 1
                XOR     AX, AX
                MOV     DS, AX
                MOV     BX, (21H*4)
                MOV     AX, ES:[OFS_KEEP21]
                MOV     DX, ES:[SEG_KEEP21]
                MOV     [BX+0], AX
                MOV     [BX+2], DX
                MOV     BX, (2FH*4)
                MOV     AX, ES:[OFS_KEEP2F]
                MOV     DX, ES:[SEG_KEEP2F]
                MOV     [BX+0], AX
                MOV     [BX+2], DX
                MOV     BX, (08H*4)
                MOV     AX, ES:[OFS_KEEP08]
                MOV     DX, ES:[SEG_KEEP08]
                MOV     [BX+0], AX
                MOV     [BX+2], DX
                STI
                MOV     AH, 49H
                INT     21H
                MOV     AX, CS
                MOV     DS, AX
                LEA     DX, [Msg_UnLoad]
                MOV     AH, 9
                INT     21H
                MOV     AX, 4C01H
                INT     21H
;---  
Message         DB      '-= T8253 TSR Emulator   V0.01 Alfa =-',0DH,0AH,'$'
Msg_Load        DB      '    Loaded.',0DH,0AH,'$'
Msg_UnLoad      DB      '    Unloaded.',0DH,0AH,'$'
CODE    ENDS
        END     BEGIN

